package com.steerinfo.dil.controller;

import com.alibaba.druid.support.json.JSONUtils;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.steerinfo.dil.service.impl.AmsNotUploadedEasServiceImpl;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.SaleUtil;
import com.steerinfo.dil.wsdl.LoginUtil;
import com.steerinfo.dil.wsdl.WSContext;
//import com.steerinfo.dil.wsdlTest.DeleteServiceInfo;
//import com.steerinfo.dil.wsdlTest.DeleteWSFaceFacadeSrvProxyServiceLocator;
import com.steerinfo.dil.wsdl.ServiceInfo;
import com.steerinfo.dil.wsdl.WSFaceFacadeSrvProxyServiceLocator;
import com.steerinfo.dil.wsdlTest.LoginTestUtil;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description:
 * @Author:HuJianGuo
 * @GreateTime:2021/11/15 18:12
 * @Version:V2.0
 */
@RestController
@RequestMapping("/${api.version}/wsface")
public class WSFaceController extends BaseRESTfulController {

    @Autowired
    SaleUtil saleUtil;

    @Autowired
    AmsNotUploadedEasServiceImpl amsNotUploadedEasService;

    @PostMapping("/pushBmsSettlement")
    @ApiModelProperty(value = "结算金蝶访问接口")
    public String WSFaceWay(@RequestBody Map<String,Object> map) {
        ServiceInfo service = new ServiceInfo("user", "kduser", "eas", "D001", "L2", 1);
        WSFaceFacadeSrvProxyServiceLocator locator = new WSFaceFacadeSrvProxyServiceLocator();
        service.setServername("172.16.62.243" , "8888");
//        DeleteServiceInfo service = new DeleteServiceInfo("user", "kduser", "eas", "D001", "L2", 1);
//        DeleteWSFaceFacadeSrvProxyServiceLocator locator = new DeleteWSFaceFacadeSrvProxyServiceLocator();
//        service.setServername("172.16.62.243" , "8888");
        String output = null;
        try {
            // 这边是map，将map封装后转为json
            String json = JSONUtils.toJSONString(map);
            String res = locator.getWSFaceFacade().invokeJson(json);
            JSONObject request = JSON.parseObject(res);
            output = request.getString("output");
            System.out.println(output);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return output;
    }

    @PostMapping("/pushSaleOrderToEas")
    @ApiModelProperty(value = "销售订单推送数据接口")
    public Map<String,Object> pushSaleOrderToEas(@RequestBody Map<String,Object> map) {
//        Map<String, Object> totalMap = saleUtil.getTotalMap();
//        totalMap.put("input",map);
        //正式服务器
        com.steerinfo.dil.wsdl.ServiceInfo service = new ServiceInfo("user", "dgjt@kingdee", "eas", "FDDGEAS85", "L2", 1);
        WSFaceFacadeSrvProxyServiceLocator locator = new WSFaceFacadeSrvProxyServiceLocator();
        service.setServername("172.16.33.111" , "8888");
        // 测试服务器
//        DeleteServiceInfo service = new DeleteServiceInfo("user", "dgjt@kingdee", "eas", "A004", "L2", 1);
//        DeleteWSFaceFacadeSrvProxyServiceLocator locator = new DeleteWSFaceFacadeSrvProxyServiceLocator();
        // 测试服务器
//        service.setServername("172.16.62.243" , "8888");

        WSContext wsContext = LoginUtil.doEASLogin(service);
        String sessionId = wsContext.getSessionId();
        String output = null;
        Map<String , Object> resultMap = new HashMap<>();
        try {
            // 这边是map，将map封装后转为json
            String json = JSONUtils.toJSONString(map);
            String res = locator.getWSFaceFacade().invokeJson(json);
            JSONObject request = JSON.parseObject(res);
            String requestException = request.getString("exception");
            output = request.getString("output");
            System.out.println(output);
            resultMap.put("res",res);
            resultMap.put("output",output);
            resultMap.put("requestException",requestException);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultMap;
    }

    @PostMapping("/pushWmsMessagesToEas")
    @ApiModelProperty(value = "仓储推送数据接口")
    public String pushWmsMessagesToEas(@RequestBody Map<String,Object> map) {
//        Map<String, Object> totalMap = saleUtil.getTotalMap();
//        totalMap.put("input",map);
        // 正式服务器
        ServiceInfo service = new ServiceInfo("user", "dgjt@kingdee", "eas", "FDDGEAS85", "L2", 1);
        WSFaceFacadeSrvProxyServiceLocator locator = new WSFaceFacadeSrvProxyServiceLocator();
        service.setServername("172.16.33.111" , "8888");
//         测试服务器
//        DeleteServiceInfo service = new DeleteServiceInfo("user", "dgjt@kingdee", "eas", "FDDGEAS85", "L2", 1);
//        DeleteWSFaceFacadeSrvProxyServiceLocator locator = new DeleteWSFaceFacadeSrvProxyServiceLocator();
//        service.setServername("172.16.33.111" , "8888");
        String output = null;
        try {
            // 这边是map，将map封装后转为json
            String json = JSONUtils.toJSONString(map);
            String res = locator.getWSFaceFacade().invokeJson(json);
            JSONObject request = JSON.parseObject(res);
            output = request.getString("output");
            System.out.println(output);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return output;
    }

    @PostMapping("/deleteSaleOrderToEas")
    @ApiModelProperty(value = "删除销售订单同步金蝶")
    public Map<String, Object> deleteSaleOrderToEas(@RequestBody Map<String,Object> map) {
        // 正式服务器
        com.steerinfo.dil.wsdl.ServiceInfo service = new ServiceInfo("user", "dgjt@kingdee", "eas", "FDDGEAS85", "L2", 0);
        WSFaceFacadeSrvProxyServiceLocator locator = new WSFaceFacadeSrvProxyServiceLocator();
        service.setServername("172.16.33.111" , "8888");
        // 测试服务器
//        DeleteServiceInfo service = new DeleteServiceInfo("user", "dgjt@kingdee", "eas", "A004", "L2", 0);
//        DeleteWSFaceFacadeSrvProxyServiceLocator locator = new DeleteWSFaceFacadeSrvProxyServiceLocator();
//        service.setServername("172.16.62.243" , "8888");
        WSContext wsContext = LoginUtil.doEASLogin(service);
        String sessionId = wsContext.getSessionId();
        Map<String , Object> resultMap = new HashMap<>();
        String output = null;
        try {
            // 这边是map，将map封装后转为json
            String json = JSONUtils.toJSONString(map);
            String res = locator.getWSFaceFacade().invokeJson(json);
            JSONObject request = JSON.parseObject(res);
            String requestException = request.getString("exception");
            output = request.getString("output");
            System.out.println(output);
            resultMap.put("res",res);
            resultMap.put("output",output);
            resultMap.put("requestException",requestException);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return resultMap;
    }

    /**
     * 生成报文传输数据接口 请勿乱调用测试
     * @Author TXF
     * @Date 2022/2/22 9:46
     * @param
     * @return
     **/
    @PostMapping("asd")
    public void asd(){
        amsNotUploadedEasService.makeXmlFile();
    }
}
